/*
 * Nsmf_EventExposure
 *
 * Session Management Event Exposure Service API
 *
 * API version: 1.0.0
 * Generated by: OpenAPI Generator (https://openapi-generator.tech)
 */

package models

import (
	"time"
)

type EventNotification struct {
	Event              SmfEvent         `json:"event" yaml:"event" bson:"event" mapstructure:"Event"`
	TimeStamp          *time.Time       `json:"timeStamp" yaml:"timeStamp" bson:"timeStamp" mapstructure:"TimeStamp"`
	Supi               string           `json:"supi,omitempty" yaml:"supi" bson:"supi" mapstructure:"Supi"`
	Gpsi               string           `json:"gpsi,omitempty" yaml:"gpsi" bson:"gpsi" mapstructure:"Gpsi"`
	SourceDnai         string           `json:"sourceDnai,omitempty" yaml:"sourceDnai" bson:"sourceDnai" mapstructure:"SourceDnai"`
	TargetDnai         string           `json:"targetDnai,omitempty" yaml:"targetDnai" bson:"targetDnai" mapstructure:"TargetDnai"`
	DnaiChgType        DnaiChangeType   `json:"dnaiChgType,omitempty" yaml:"dnaiChgType" bson:"dnaiChgType" mapstructure:"DnaiChgType"`
	SourceUeIpv4Addr   string           `json:"sourceUeIpv4Addr,omitempty" yaml:"sourceUeIpv4Addr" bson:"sourceUeIpv4Addr" mapstructure:"SourceUeIpv4Addr"`
	SourceUeIpv6Prefix string           `json:"sourceUeIpv6Prefix,omitempty" yaml:"sourceUeIpv6Prefix" bson:"sourceUeIpv6Prefix" mapstructure:"SourceUeIpv6Prefix"`
	TargetUeIpv4Addr   string           `json:"targetUeIpv4Addr,omitempty" yaml:"targetUeIpv4Addr" bson:"targetUeIpv4Addr" mapstructure:"TargetUeIpv4Addr"`
	TargetUeIpv6Prefix string           `json:"targetUeIpv6Prefix,omitempty" yaml:"targetUeIpv6Prefix" bson:"targetUeIpv6Prefix" mapstructure:"TargetUeIpv6Prefix"`
	SourceTraRouting   *RouteToLocation `json:"sourceTraRouting,omitempty" yaml:"sourceTraRouting" bson:"sourceTraRouting" mapstructure:"SourceTraRouting"`
	TargetTraRouting   *RouteToLocation `json:"targetTraRouting,omitempty" yaml:"targetTraRouting" bson:"targetTraRouting" mapstructure:"TargetTraRouting"`
	UeMac              string           `json:"ueMac,omitempty" yaml:"ueMac" bson:"ueMac" mapstructure:"UeMac"`
	AdIpv4Addr         string           `json:"adIpv4Addr,omitempty" yaml:"adIpv4Addr" bson:"adIpv4Addr" mapstructure:"AdIpv4Addr"`
	AdIpv6Prefix       string           `json:"adIpv6Prefix,omitempty" yaml:"adIpv6Prefix" bson:"adIpv6Prefix" mapstructure:"AdIpv6Prefix"`
	ReIpv4Addr         string           `json:"reIpv4Addr,omitempty" yaml:"reIpv4Addr" bson:"reIpv4Addr" mapstructure:"ReIpv4Addr"`
	ReIpv6Prefix       string           `json:"reIpv6Prefix,omitempty" yaml:"reIpv6Prefix" bson:"reIpv6Prefix" mapstructure:"ReIpv6Prefix"`
	PlmnId             *PlmnId          `json:"plmnId,omitempty" yaml:"plmnId" bson:"plmnId" mapstructure:"PlmnId"`
	AccType            AccessType       `json:"accType,omitempty" yaml:"accType" bson:"accType" mapstructure:"AccType"`
	PduSeId            int32            `json:"pduSeId,omitempty" yaml:"pduSeId" bson:"pduSeId" mapstructure:"PduSeId"`
}
